var sound;
var asXML;
var spTimer;
var defaultVolume = 100;
var mutedVolume = 100;
var defaultBG = 1;
var defaultStation = 10;
var defaultState = 0;
var activeStationsNamesArray = new Array();
var activeStationsURLSArray = new Array();

function init(){
	System.Gadget.settingsUI = '../html/settings.html';
	System.Gadget.onSettingsClosed = onSettingsClosed;
	sound = GetLibrary();
	if(loadSettings()){
		setBG(defaultBG);
		setVol(defaultVolume);		
		loadActiveStations();
		loadStation(defaultStation);
		var timer = setInterval(getTimeInfo, 1000);
		spTimer = setInterval(setSoundPulse, 10);
		var saveSettingsTimer = setInterval(saveSettings, 30000);
	}
}

function onSettingsClosed(event){
	if(event.closeAction == event.Action.commit){
		loadActiveStations();
	}
	self.focus();
}

function loadActiveStations(){
	//Open XML file
	asXML = new ActiveXObject("Msxml2.DOMDocument.3.0");
	asXML.async = false;
	asXML.load(System.Gadget.path + "\\xml\\activeStations.xml");
	if (asXML.parseError.errorCode != 0) {
		var myErr = asXML.parseError;
		document.getElementById('displayText').innerHTML = 'Unable to load XML ' + myErr.reason;
	} else {
   		while(activeStationsNamesArray.length > 0){
			activeStationsNamesArray.pop();
		}
		while(activeStationsURLSArray.length > 0){
			activeStationsURLSArray.pop();
		}
		var activeStations = asXML.documentElement;		
		for(i=0;i<activeStations.childNodes.length;i++){
			var station = activeStations.childNodes[i];
			activeStationsNamesArray.push(station.childNodes[0].text);
			activeStationsURLSArray.push(station.childNodes[1].text);
		}
		for(s=1;s<=12;s++){
			document.getElementById('stationSel' + s).title = activeStationsNamesArray[s - 1];
		}
	}
}

function loadSettings(){
	var reg = new RegistryObj();	
	if(reg.readDWORDValue("defaultVolume") != null){
		defaultVolume = reg.readDWORDValue("defaultVolume");
	}
	if(reg.readDWORDValue("defaultBG") != null){
		defaultBG = reg.readDWORDValue("defaultBG");
	}
	if(reg.readDWORDValue("defaultStation") != null){
		defaultStation = reg.readDWORDValue("defaultStation");
	}
	if(reg.readDWORDValue("defaultState") != null){
		defaultState = reg.readDWORDValue("defaultState");
	}
	if(reg.readDWORDValue("defaultBG") != null){
		defaultBG = reg.readDWORDValue("defaultBG");
	}
	return true;
}

function saveSettings(){
	registry = new RegistryObj();
	registry.createKey();
	registry.writeDWORDValue("defaultVolume", defaultVolume);
	registry.writeDWORDValue("defaultStation", defaultStation);
	registry.writeDWORDValue("defaultState", defaultState);
	registry.writeDWORDValue("defaultBG", defaultBG);
	UnregisterLibrary();
}

function setBG(bg){
	switch(bg){
		case 0:
			document.body.style.backgroundImage = "url(../images/NetDirect_v3.5_bg_bw.png)";
			document.getElementById('displayText').style.color = "#CCCCCC";
			document.getElementById('clockDisplay').style.color = "#CCCCCC";
			document.getElementById('stationSelIndicator').style.backgroundColor = "#CCCCCC";
			document.getElementById('soundPulse').style.backgroundColor = "#CCCCCC";
			break;
		case 1:
			document.body.style.backgroundImage = "url(../images/NetDirect_v3.5_bg_warm.png)";
			document.getElementById('displayText').style.color = "#E5891C";
			document.getElementById('clockDisplay').style.color = "#E5891C";
			document.getElementById('stationSelIndicator').style.backgroundColor = "#E5891C";
			document.getElementById('soundPulse').style.backgroundColor = "#E5891C";
			break;
		case 2:
			document.body.style.backgroundImage = "url(../images/NetDirect_v3.5_bg_cold.png)";
			document.getElementById('displayText').style.color = "#99CCFF";
			document.getElementById('clockDisplay').style.color = "#99CCFF";
			document.getElementById('stationSelIndicator').style.backgroundColor = "#99CCFF";
			document.getElementById('soundPulse').style.backgroundColor = "#99CCFF";
			break;
	}
	defaultBG = bg;
}

function getTimeInfo(){
	var currentTime = new Date();
	var h = currentTime.getHours();
	var m = currentTime.getMinutes();
	var s = currentTime.getSeconds();
	if(m.toString().length == 1){
		m = '0' + m;
	}
	if(s.toString().length == 1){
		s = '0' + s;
	}
	document.getElementById('clockDisplay').innerHTML = h + ':' + m + ':' + s;
	
}

function setSoundPulse(){
	var averagePeek = Math.round((sound.LeftPeak + sound.RightPeak) / 2);
	document.getElementById('soundPulse').style.width = (Math.round((widthPercent(62,averagePeek) / 4)) * 4);
}

function widthPercent(maxWidth,percent){
	return (maxWidth / 100) * percent;
}

function setVol(vol){
	document.getElementById('volDisplay').style.backgroundImage = "url(../images/NetDirect_v3.5_vol_sel_indicator_" + vol + ".png)";
	defaultVolume = vol;
	//set player volume
	document.getElementById('MP').settings.volume = defaultVolume;
}

function mute(){
	if(defaultVolume > 0){
		mutedVolume = defaultVolume;
		setVol(0);
	}else{
		setVol(mutedVolume);
	}
}

function loadStation(station){
	clearInterval(spTimer);
	document.getElementById('MP').controls.stop();
	var newPos = new Number();
	if(station < 12){
		newPos = 8 + (9 * (station - 1));
	}else if(station == 12){
		newPos = 7 + (9 * (station - 1));
	}
	document.getElementById('stationSelIndicator').style.left = newPos + "px";
	if(defaultState){
		document.getElementById('displayText').innerHTML = activeStationsNamesArray[(station - 1)];
		if(activeStationsURLSArray[(station - 1)].indexOf('.pls') != -1){
			var xml_msg = new ActiveXObject("Microsoft.XMLHTTP");		
			xml_msg.onreadystatechange = function() {
	    		if(xml_msg.readyState == 4){
					if(xml_msg.status == 200){
						var playList = xml_msg.responseText;
						var playListItem = playList.substring((playList.indexOf('File1=') + 6), playList.indexOf('Title1='));
						document.getElementById('MP').URL = playListItem;
						document.getElementById('MP').controls.play();
						spTimer = setInterval(setSoundPulse, 10);
					}
				}
			}
			xml_msg.open("GET", unescape(activeStationsURLSArray[(station - 1)]), true);		
			xml_msg.send();
		}else{
			document.getElementById('MP').URL = activeStationsURLSArray[(station - 1)];
			document.getElementById('MP').controls.play();
			spTimer = setInterval(setSoundPulse, 10);
		}
		
	}
	defaultStation = station;
}

function power(){	
	if(defaultState == 0){
		defaultState = 1;
		loadStation(defaultStation);		
	}else{
		defaultState = 0;		
		//unload station
		clearInterval(spTimer);
		document.getElementById('displayText').innerHTML = '';
		document.getElementById('MP').controls.stop();
	}
}