// JavaScript Document
var asBtnState = 1;
var svBtnState = !asBtnState;
var asXML;
var activeStations;
var station;
var svXML;
var stationVault;
var svStation;
var svsSelectedStation = -1;
var svsFrom = -1;

function init(){
	System.Gadget.onSettingsClosing = SettingsClosing;
	document.getElementById('asBtn').disabled = asBtnState;
	document.getElementById('asBtn').style.cursor = 'default';
	document.getElementById('svBtn').disabled = svBtnState;
	document.getElementById('svBtn').style.cursor = 'hand';
	loadAS();
	loadSV();
}

function loadAS(){
	asXML = new ActiveXObject("Msxml2.DOMDocument.3.0");
	asXML.async = false;
	asXML.load(System.Gadget.path + "\\xml\\activeStations.xml");
	if (asXML.parseError.errorCode != 0) {
		var myErr = asXML.parseError;		
	} else {   		
		populateAS();
	}
}

function populateAS(){
	activeStations = asXML.documentElement;		
	for(i=0;i<activeStations.childNodes.length;i++){
		station = activeStations.childNodes[i];
		document.getElementById('as' + (i + 1)).innerHTML = '&nbsp;&nbsp;' + station.childNodes[0].text;
		document.getElementById('as' + (i + 1)).title = station.childNodes[1].text;
	}
}

function saveAS(){
	asXML.save(System.Gadget.path + "\\xml\\activeStations.xml");
}

function editAS(id){
	document.getElementById('stationId').value = id;
	station = activeStations.childNodes[(id - 1)];
	document.getElementById('stationName').value = station.childNodes[0].text;
	document.getElementById('stationURL').value = station.childNodes[1].text;
	document.getElementById('okBtn').onclick = updateAS;
	showEditStationWindow();
}

function showEditStationWindow(){
	document.getElementById('asBtn').disabled = true;
	document.getElementById('svBtn').disabled = true;
	document.getElementById('asBtn').style.cursor = 'default';
	document.getElementById('svBtn').style.cursor = 'default';
	document.getElementById('activeStationsSettings').style.visibility = 'hidden';
	document.getElementById('stationVaultSettings').style.visibility = 'hidden';
	document.getElementById('editStation').style.visibility = 'visible';
}

function updateAS(){
	var id = new Number(document.getElementById('stationId').value);
	station = activeStations.childNodes[(id - 1)];
	station.childNodes[0].text = document.getElementById('stationName').value;
	var urlTxt = document.getElementById('stationURL').value;
	if(urlTxt.indexOf('&') != -1){
		if(urlTxt.indexOf('&amp;') == -1){
			urlTxt.replace(/&/g, '&amp;');
		}
	}
	station.childNodes[1].text = urlTxt;
	populateAS();
	hideEditStationWindow();	
}

function hideEditStationWindow(){
	if(asBtnState){
		document.getElementById('svBtn').disabled = false;
		document.getElementById('svBtn').style.cursor = 'hand';
		document.getElementById('activeStationsSettings').style.visibility = 'visible';
	}else{
		document.getElementById('asBtn').disabled = false;
		document.getElementById('asBtn').style.cursor = 'hand';
		document.getElementById('stationVaultSettings').style.visibility = 'visible';
	}
	document.getElementById('editStation').style.visibility = 'hidden';
}

function showSVSelectorWindow(){
	document.getElementById('asBtn').disabled = true;
	document.getElementById('svBtn').disabled = true;
	document.getElementById('asBtn').style.cursor = 'default';
	document.getElementById('svBtn').style.cursor = 'default';
	document.getElementById('activeStationsSettings').style.visibility = 'hidden';
	document.getElementById('stationVaultSettings').style.visibility = 'hidden';
	document.getElementById('svSelector').style.visibility = 'visible';
}

function hideSVSelectorWindow(){
	if(asBtnState){
		document.getElementById('svBtn').disabled = false;
		document.getElementById('svBtn').style.cursor = 'hand';
		document.getElementById('activeStationsSettings').style.visibility = 'visible';
	}else{
		document.getElementById('asBtn').disabled = false;
		document.getElementById('asBtn').style.cursor = 'hand';
		document.getElementById('stationVaultSettings').style.visibility = 'visible';
	}
	document.getElementById('svSelector').style.visibility = 'hidden';
}

function swapAS(id){
	svsSelectedStation = -1;
	svsFrom = id;
	var svsList = '<table width="238" border="0" cellspacing="0" cellpadding="0">';
	for(i=0;i<stationVault.childNodes.length;i++){
		svStation = stationVault.childNodes[i];
		svsList = svsList + '      <tr>';
		svsList = svsList + '        <td width="20">&nbsp;</td>';
		svsList = svsList + '        <td width="198">&nbsp;</td>';
		svsList = svsList + '        <td width="20">&nbsp;</td>';
		svsList = svsList + '      </tr>';
		svsList = svsList + '      <tr title="' + svStation.childNodes[1].text + '" id="svsItem' + (i + 1) + '" class="svsItem" onmouseover="if(this.style.backgroundColor == \'\'){this.style.backgroundColor = \'#CCCCCC\';}" onmouseout="if(this.style.backgroundColor != \'#666666\'){this.style.backgroundColor = \'\';}" onmousedown="if(svsSelectedStation == -1){this.style.backgroundColor = \'#666666\';svsSelectedStation = ' + (i + 1) + ';}else if((svsSelectedStation != ' + (i + 1) + ') && (svsSelectedStation != -1)){document.getElementById(\'svsItem\' + svsSelectedStation).style.backgroundColor = \'\';this.style.backgroundColor = \'#666666\';svsSelectedStation = ' + (i + 1) + ';}else if(svsSelectedStation == ' + (i + 1) + '){this.style.backgroundColor = \'#CCCCCC\';svsSelectedStation = -1;}">';
		svsList = svsList + '        <td width="20">' + (i + 1) + '.</td>';
		svsList = svsList + '        <td width="198">&nbsp;&nbsp;' + svStation.childNodes[0].text + '</td>';
		svsList = svsList + '        <td width="20"><input type="hidden" name="svsId" id="svsId" value="' + (i + 1) + '" /></td>';
		svsList = svsList + '      </tr>';
	}
	svsList = svsList + '</table>';
	document.getElementById('stationList').innerHTML = svsList;
	station = activeStations.childNodes[(id - 1)];
	document.getElementById('svsHeader').innerHTML = 'Swap ' + station.childNodes[0].text + ' with:';
	showSVSelectorWindow();
}

function doSwap(){
	svStation = stationVault.childNodes[(svsSelectedStation - 1)];
	station = activeStations.childNodes[(svsFrom - 1)];
	var tmpStationName = station.childNodes[0].text;
	var tmpStationURL = station.childNodes[1].text;
	station.childNodes[0].text = svStation.childNodes[0].text;
	station.childNodes[1].text = svStation.childNodes[1].text;
	svStation.childNodes[0].text = tmpStationName;
	svStation.childNodes[1].text = tmpStationURL;
	populateAS();
	hideSVSelectorWindow();	
}

function loadSV(){
	svXML = new ActiveXObject("Msxml2.DOMDocument.3.0");
	svXML.async = false;
	svXML.load(System.Gadget.path + "\\xml\\stationVault.xml");
	if (svXML.parseError.errorCode != 0) {
		var myErr = svXML.parseError;		
	} else {   		
		populateSV();
	}
}

function populateSV(){
	stationVault = svXML.documentElement;
	var svTable = '<table width="238" border="0" align="center" cellpadding="0" cellspacing="0">';
	for(i=0;i<stationVault.childNodes.length;i++){
		svStation = stationVault.childNodes[i];
		svTable = svTable + '<tr>';
		svTable = svTable + '      <td align="right">&nbsp;</td>';
		svTable = svTable + '      <td width="184" align="left">&nbsp;</td>';
		svTable = svTable + '      <td width="34" align="right">&nbsp;</td>';
		svTable = svTable + '    </tr>';
		svTable = svTable + '    <tr>';
		svTable = svTable + '      <td width="20" align="right" valign="middle">' + (i + 1) + '.</td>';
		svTable = svTable + '      <td width="184" align="left" valign="middle" id="sv' + (i + 1) + '" title="' + svStation.childNodes[1].text + '">&nbsp;&nbsp;' + svStation.childNodes[0].text + '</td>';
		svTable = svTable + '      <td width="34" align="right"><img src="../images/NetDirect_v3.5_settings_edit_btn.png" width="16" height="16" hspace="1" border="0" class="swapBtn" title="Edit station..." onclick="editStation(' + (i + 1) + ');" onmouseover="this.src = \'../images/NetDirect_v3.5_settings_edit_btn_over.png\';" onmouseout="this.src = \'../images/NetDirect_v3.5_settings_edit_btn.png\';" /><img src="../images/NetDirect_v3.5_settings_delete_btn.png" onclick="deleteStation(' + (i + 1) + ');" onmouseover="this.src = \'../images/NetDirect_v3.5_settings_delete_btn_over.png\';" onmouseout="this.src = \'../images/NetDirect_v3.5_settings_delete_btn.png\';" width="16" height="16" border="0" class="swapBtn" title="Delete station..." /></td>';
		svTable = svTable + '    </tr>';
	}
	svTable = svTable + "</table>";
	document.getElementById('svStations').innerHTML = svTable;
}

function saveSV(){
	svXML.save(System.Gadget.path + "\\xml\\stationVault.xml");
}

function editStation(id){
	document.getElementById('stationId').value = id;
	svStation = stationVault.childNodes[(id - 1)];
	document.getElementById('stationName').value = svStation.childNodes[0].text;
	document.getElementById('stationURL').value = svStation.childNodes[1].text;
	document.getElementById('okBtn').onclick = updateStation;
	showEditStationWindow();
}

function deleteStation(id){
	var deletedStation;
	deletedStation = stationVault.removeChild(stationVault.childNodes.item((id - 1)));
	populateSV();
}

function addStation(){
	var stationNode, nameNode, URLNode;
	stationNode = svXML.createNode(1, "STATION", "");
	stationVault.appendChild(stationNode);
	nameNode = svXML.createNode(1, "STATION_NAME", "");
	URLNode = svXML.createNode(1, "STATION_URL", "");
	stationNode.appendChild(nameNode);
	stationNode.appendChild(URLNode);
	stationNode.childNodes[0].text = document.getElementById('newStationName').value;
	var urlTxt = document.getElementById('newStationURL').value;
	if(urlTxt.indexOf('&') != -1){
		if(urlTxt.indexOf('&amp;') == -1){
			urlTxt.replace(/&/g, '&amp;');
		}
	}
	stationNode.childNodes[1].text = urlTxt;
	populateSV();
	document.getElementById('newStationName').value = '';
	document.getElementById('newStationURL').value = '';
}

function updateStation(){
	var id = new Number(document.getElementById('stationId').value);
	svStation = stationVault.childNodes[(id - 1)];
	svStation.childNodes[0].text = document.getElementById('stationName').value;
	var urlTxt = document.getElementById('stationURL').value;
	if(urlTxt.indexOf('&') != -1){
		if(urlTxt.indexOf('&amp;') == -1){
			urlTxt.replace(/&/g, '&amp;');
		}
	}
	svStation.childNodes[1].text = urlTxt;
	populateSV();
	hideEditStationWindow();
}

function SettingsClosing(event){
    // User hit OK on the settings page.
	if (event.closeAction == event.Action.commit){
        saveAS();
		saveSV();
    }
    // Allow the Settings dialog to close.
    event.cancel = false;
}

function changeButton(btn, bgColor, fontColor){
	btn.style.backgroundColor = bgColor;
	btn.style.color = fontColor;
}

function displaySettingsPage(page){
	switch(page){
		case 0:
			asBtnState = 1;
			svBtnState = !asBtnState;
			changeButton(document.getElementById('asBtn'), '#666666', '#FFFFFF');
			changeButton(document.getElementById('svBtn'), '#CCCCCC', '#FFFFFF');
			document.getElementById('asBtn').disabled = asBtnState;
			document.getElementById('asBtn').style.cursor = 'default';
			document.getElementById('svBtn').disabled = svBtnState;	
			document.getElementById('svBtn').style.cursor = 'hand';
			document.getElementById('activeStationsSettings').style.visibility = 'visible';
			document.getElementById('stationVaultSettings').style.visibility = 'hidden';
			break;
		case 1:
			svBtnState = 1;
			asBtnState = !svBtnState;
			changeButton(document.getElementById('svBtn'), '#666666', '#FFFFFF');
			changeButton(document.getElementById('asBtn'), '#CCCCCC', '#FFFFFF');
			document.getElementById('asBtn').disabled = asBtnState;
			document.getElementById('asBtn').style.cursor = 'hand';
			document.getElementById('svBtn').disabled = svBtnState;
			document.getElementById('svBtn').style.cursor = 'default';
			document.getElementById('stationVaultSettings').style.visibility = 'visible';
			document.getElementById('activeStationsSettings').style.visibility = 'hidden';
			break;
	}
}

/*
function openXML(list){
	switch(list){
		case 'as':
			System.Shell.execute(System.Gadget.path + "\\xml\\activeStations.xml", null, null, 'open');
			break;
		case 'sv':
			System.Shell.execute(System.Gadget.path + "\\xml\\stationVault.xml", null, null, 'open');
			break;
	}
	System.Gadget.Settings.document.parentWin.closeSettings();
}
*/